/**
 * I might try to interop with FAST's observer stuff in fast-element if it makes it easier to consume
 * import {Observable} from '@microsoft/fast-element';
 * Keeping in simple for now... revisit.
 */
export type Listener<EventType> = (ev: EventType) => void;
export type Subscribe<EventType> = (listener: Listener<EventType>) => () => void;
export type Publish<EventType> = (event: EventType) => void;
export interface Observer<EventType> {
    subscribe: Subscribe<EventType>;
    publish: Publish<EventType>;
}
export declare const createObserver: <EventType>() => Observer<EventType>;
/**
 * Setup an `IntersectionObserver` which will activate a callback function when an element becomes visible on screen
 * @param element - HTMLElement to observe
 * @param callback - (boolean) => any function called when the visibility changes
 * @public
 */
export declare const respondToVisibility: (element: HTMLElement, callback: (arg0: boolean) => any) => void;
//# sourceMappingURL=observer.d.ts.map